﻿#region Using directives

using System;
using System.Text;
using System.Globalization;

#endregion

namespace MonsieurWJ.LibXMS2 {

	/// <summary>
	/// Hexadecimal Encoding
	/// </summary>
	public class HexEncoding:Encoding {

		private static HexEncoding encoding = null;

		static HexEncoding() {
			encoding = new HexEncoding();
		}

		public HexEncoding() {
		}

		/// <summary>
		/// Gets Default Instance of HexEncoding
		/// </summary>
		/// <value>Default Instance of HexEncoding</value>
		public static Encoding HEX {
			get {
				return encoding;
			}
		}

		public override int GetByteCount(char[] chars, int index, int count) {
			return (count >> 1);
		}

		public override int GetBytes(char[] chars, int charIndex, int charCount, byte[] bytes, int byteIndex) {
			int len = charCount >> 1;
			string x = null;

			for (int j = 0; j < len; j++) {
				x = new string(chars, charIndex + (j << 1), 2);
				bytes[byteIndex + j] = Byte.Parse(x, NumberStyles.HexNumber);
			}

			return len;
		}

		public override int GetCharCount(byte[] bytes, int index, int count) {
			return (count << 1);
		}

		public override int GetChars(byte[] bytes, int byteIndex, int byteCount, char[] chars, int charIndex) {
			string x = null;
			for (int i = 0; i < byteCount; i++) {
				x = bytes[byteIndex+i].ToString("X").PadLeft(2,'0');
				x.CopyTo(0, chars, charIndex + (i << 1), 2);
			}

			return byteCount << 1;
		}

		public override int GetMaxByteCount(int charCount) {
			return (charCount >> 1);
		}

		public override int GetMaxCharCount(int byteCount) {
			return (byteCount << 1);
		}
	}
}
