﻿#region Using directives

using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.ComponentModel;

using MonsieurWJ.LibXMS2;
using MonsieurWJ.LibXMS2.Communicators.Basic;

using WahJava.MyExams.Properties;

#endregion

namespace WahJava.MyExams {
	partial class MainForm : Form {

		private Modem currentModem = null;
		private XMS xms = null;
		private ICommunicator comm = null;
		private MessageStore currentMS = MessageStore.SIM;
		private MessageFolder currentMF = MessageFolder.Read;
		private string currentPB = "SM";

		private ToolStripDropDownButton cmbModems;
		private RaftingContainer leftRaftingContainer;
		private RaftingContainer rightRaftingContainer;
		private RaftingContainer bottomRaftingContainer;

		private ToolStripLabel lblModem;
		private ToolStripButton btnStart;
		public MainForm() {
			InitializeComponent();
			this.InitStuff();
		}

		private void InitStuff() {
			ICollection m = Modem.GetModems();
			foreach (Modem x in m) {
				ToolStripMenuItem btn = new ToolStripMenuItem();
				btn.AutoToolTip = true;
				btn.Text = x.ToString();
				btn.ToolTipText = "Select " + btn.Text;
				btn.Tag = x;
				btn.DisplayStyle = ToolStripItemDisplayStyle.ImageAndText;
				btn.Image = Resources.Phone;
				btn.Click += new EventHandler(btnModemsClicked);
				cmbModems.DropDownItems.Add(btn); //.Add(x);
			}
		}

		private void btnModemsClicked(object sender, EventArgs e) {
			ToolStripMenuItem m1 = sender as ToolStripMenuItem;
			Modem m = m1.Tag as Modem;
			this.currentModem = m;
			lblModem.Text = m.ToString()+" - "+
				(this.currentModem.Status ? "OK":"Not Present or Error");
			lblModem.ToolTipText = "Selected Modem: " + lblModem.Text+" - "+
				(this.currentModem.Status ? "OK":"Not Present or Error");

			if (m.Status)
				btnStart.Enabled = true;
			else
				btnStart.Enabled = false;
		}

		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Windows.Forms.ToolStrip myToolStrip;
			System.Windows.Forms.RaftingContainer topRaftingContainer;
			System.Windows.Forms.ToolStripDropDownButton messageStoreToolStripButton;
			System.Windows.Forms.ColumnHeader chMsgID;
			System.Windows.Forms.ColumnHeader chMsgType;
			System.Windows.Forms.ColumnHeader chMsgText;
			System.Windows.Forms.ColumnHeader chFromTo;
			System.Windows.Forms.ColumnHeader chTimestamp;
			System.Windows.Forms.ToolStripMenuItem sIMToolStripMenuItem1;
			System.Windows.Forms.ToolStripMenuItem pBToolStripMenuItem;
			System.Windows.Forms.ToolStripSeparator toolStripSeparator1;
			System.Windows.Forms.ToolStripMenuItem missedCallsToolStripMenuItem;
			System.Windows.Forms.ToolStripMenuItem dialledCallsToolStripMenuItem;
			System.Windows.Forms.ToolStripMenuItem receivedCallsMenuItem;
			System.Windows.Forms.ToolStripSeparator toolStripSeparator2;
			System.Windows.Forms.ToolStripMenuItem fixedDiallingMenuItem;
			System.Windows.Forms.ColumnHeader chPbID;
			System.Windows.Forms.ColumnHeader chPbName;
			System.Windows.Forms.ColumnHeader chPbFone;
			System.Windows.Forms.TabPage tabComposer;
			System.Windows.Forms.Label label5;
			System.Windows.Forms.Label label4;
			System.Windows.Forms.Label label3;
			System.Windows.Forms.Label label1;
			System.Windows.Forms.ColumnHeader chEncoding;
			System.Windows.Forms.ContextMenuStrip ctxMessages;
			System.Windows.Forms.ToolStripMenuItem mctxMsgDelete;
			System.Windows.Forms.ContextMenuStrip ctxPB;
			System.Windows.Forms.ToolStripMenuItem mctxPBDelete;
			this.cmbModems = new System.Windows.Forms.ToolStripDropDownButton();
			this.lblModem = new System.Windows.Forms.ToolStripLabel();
			this.btnStart = new System.Windows.Forms.ToolStripButton();
			this.phoneToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.sIMToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.cmbMessageStore = new System.Windows.Forms.ComboBox();
			this.chkDelivery = new System.Windows.Forms.CheckBox();
			this.btnSend = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.cmbClass = new System.Windows.Forms.ComboBox();
			this.cmbEncoding = new System.Windows.Forms.ComboBox();
			this.txtMessage = new System.Windows.Forms.TextBox();
			this.txtTO = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.toolsPB = new System.Windows.Forms.ToolStrip();
			this.phoneBookToolStripButton = new System.Windows.Forms.ToolStripDropDownButton();
			this.txtLocation = new System.Windows.Forms.ToolStripTextBox();
			this.txtName = new System.Windows.Forms.ToolStripTextBox();
			this.txtPhone = new System.Windows.Forms.ToolStripTextBox();
			this.btnAddContact = new System.Windows.Forms.ToolStripButton();
			this.toolsMessages = new System.Windows.Forms.ToolStrip();
			this.messageFolderToolStripButton = new System.Windows.Forms.ToolStripDropDownButton();
			this.readToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.unreadToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.sentToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.unsentToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.fetchToolStripButton = new System.Windows.Forms.ToolStripButton();
			this.lblStatusMsg = new System.Windows.Forms.ToolStripLabel();
			this.leftRaftingContainer = new System.Windows.Forms.RaftingContainer();
			this.rightRaftingContainer = new System.Windows.Forms.RaftingContainer();
			this.bottomRaftingContainer = new System.Windows.Forms.RaftingContainer();
			this.tabbedPane = new System.Windows.Forms.TabControl();
			this.tabPhoneInfo = new System.Windows.Forms.TabPage();
			this.txtPhoneInfo = new System.Windows.Forms.TextBox();
			this.tabMessages = new System.Windows.Forms.TabPage();
			this.listMessages = new System.Windows.Forms.ListView();
			this.tabPB = new System.Windows.Forms.TabPage();
			this.listPB = new System.Windows.Forms.ListView();
			this.toolTip = new System.Windows.Forms.ToolTip(this.components);
			myToolStrip = new System.Windows.Forms.ToolStrip();
			topRaftingContainer = new System.Windows.Forms.RaftingContainer();
			messageStoreToolStripButton = new System.Windows.Forms.ToolStripDropDownButton();
			chMsgID = new System.Windows.Forms.ColumnHeader("");
			chMsgType = new System.Windows.Forms.ColumnHeader("");
			chMsgText = new System.Windows.Forms.ColumnHeader("");
			chFromTo = new System.Windows.Forms.ColumnHeader("");
			chTimestamp = new System.Windows.Forms.ColumnHeader("");
			sIMToolStripMenuItem1 = new System.Windows.Forms.ToolStripMenuItem();
			pBToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
			missedCallsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			dialledCallsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			receivedCallsMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			toolStripSeparator2 = new System.Windows.Forms.ToolStripSeparator();
			fixedDiallingMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			chPbID = new System.Windows.Forms.ColumnHeader("");
			chPbName = new System.Windows.Forms.ColumnHeader("");
			chPbFone = new System.Windows.Forms.ColumnHeader("");
			tabComposer = new System.Windows.Forms.TabPage();
			label5 = new System.Windows.Forms.Label();
			label4 = new System.Windows.Forms.Label();
			label3 = new System.Windows.Forms.Label();
			label1 = new System.Windows.Forms.Label();
			chEncoding = new System.Windows.Forms.ColumnHeader("");
			ctxMessages = new System.Windows.Forms.ContextMenuStrip(this.components);
			mctxMsgDelete = new System.Windows.Forms.ToolStripMenuItem();
			ctxPB = new System.Windows.Forms.ContextMenuStrip(this.components);
			mctxPBDelete = new System.Windows.Forms.ToolStripMenuItem();
			myToolStrip.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(topRaftingContainer)).BeginInit();
			topRaftingContainer.SuspendLayout();
			tabComposer.SuspendLayout();
			ctxMessages.SuspendLayout();
			ctxPB.SuspendLayout();
			this.toolsPB.SuspendLayout();
			this.toolsMessages.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.leftRaftingContainer)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.rightRaftingContainer)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.bottomRaftingContainer)).BeginInit();
			this.tabbedPane.SuspendLayout();
			this.tabPhoneInfo.SuspendLayout();
			this.tabMessages.SuspendLayout();
			this.tabPB.SuspendLayout();
			this.SuspendLayout();
// 
// myToolStrip
// 
			myToolStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.cmbModems,
            this.lblModem,
            this.btnStart});
			myToolStrip.Location = new System.Drawing.Point(0, 0);
			myToolStrip.Name = "myToolStrip";
			myToolStrip.Raft = System.Windows.Forms.RaftingSides.Top;
			myToolStrip.Size = new System.Drawing.Size(194, 53);
			myToolStrip.TabIndex = 0;
// 
// cmbModems
// 
			this.cmbModems.Name = "cmbModems";
			this.cmbModems.SettingsKey = "MainForm.listofModemsToolStripDropDownButton";
			this.cmbModems.Text = "List of Modems";
// 
// lblModem
// 
			this.lblModem.Name = "lblModem";
			this.lblModem.SettingsKey = "MainForm.lblModem";
// 
// btnStart
// 
			this.btnStart.Enabled = false;
			this.btnStart.Name = "btnStart";
			this.btnStart.SettingsKey = "MainForm.startToolStripButton";
			this.btnStart.Text = "Start Connection";
			this.btnStart.Click += new System.EventHandler(this.startCommunication);
// 
// topRaftingContainer
// 
			topRaftingContainer.Controls.Add(myToolStrip);
			topRaftingContainer.Dock = System.Windows.Forms.DockStyle.Top;
			topRaftingContainer.Name = "topRaftingContainer";
// 
// messageStoreToolStripButton
// 
			messageStoreToolStripButton.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
			messageStoreToolStripButton.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.phoneToolStripMenuItem,
            this.sIMToolStripMenuItem});
			messageStoreToolStripButton.Name = "messageStoreToolStripButton";
			messageStoreToolStripButton.SettingsKey = "MainForm.messageStoreToolStripButton";
			messageStoreToolStripButton.Text = "Message &Store";
			messageStoreToolStripButton.DropDownItemClicked += new System.Windows.Forms.ToolStripItemClickedEventHandler(this.storeSelected);
// 
// phoneToolStripMenuItem
// 
			this.phoneToolStripMenuItem.Name = "phoneToolStripMenuItem";
			this.phoneToolStripMenuItem.SettingsKey = "MainForm.phoneToolStripMenuItem";
			this.phoneToolStripMenuItem.Text = "&Phone";
// 
// sIMToolStripMenuItem
// 
			this.sIMToolStripMenuItem.Name = "sIMToolStripMenuItem";
			this.sIMToolStripMenuItem.SettingsKey = "MainForm.sIMToolStripMenuItem";
			this.sIMToolStripMenuItem.Text = "&SIM";
// 
// chMsgID
// 
			chMsgID.Text = "Message ID";
// 
// chMsgType
// 
			chMsgType.Text = "Message Type";
// 
// chMsgText
// 
			chMsgText.Text = "Message Text";
			chMsgText.Width = 160;
// 
// chFromTo
// 
			chFromTo.Text = "From/To";
// 
// chTimestamp
// 
			chTimestamp.Text = "Timestamp";
// 
// sIMToolStripMenuItem1
// 
			sIMToolStripMenuItem1.Name = "sIMToolStripMenuItem1";
			sIMToolStripMenuItem1.SettingsKey = "MainForm.sIMToolStripMenuItem1";
			sIMToolStripMenuItem1.Tag = "SM";
			sIMToolStripMenuItem1.Text = "&SIM";
// 
// pBToolStripMenuItem
// 
			pBToolStripMenuItem.Name = "pBToolStripMenuItem";
			pBToolStripMenuItem.SettingsKey = "MainForm.pBToolStripMenuItem";
			pBToolStripMenuItem.Tag = "ME";
			pBToolStripMenuItem.Text = "&Phone";
// 
// toolStripSeparator1
// 
			toolStripSeparator1.Name = "toolStripSeparator1";
			toolStripSeparator1.SettingsKey = "MainForm.toolStripSeparator1";
// 
// missedCallsToolStripMenuItem
// 
			missedCallsToolStripMenuItem.Name = "missedCallsToolStripMenuItem";
			missedCallsToolStripMenuItem.SettingsKey = "MainForm.missedCallsToolStripMenuItem";
			missedCallsToolStripMenuItem.Tag = "MC";
			missedCallsToolStripMenuItem.Text = "&Missed Calls";
// 
// dialledCallsToolStripMenuItem
// 
			dialledCallsToolStripMenuItem.Name = "dialledCallsToolStripMenuItem";
			dialledCallsToolStripMenuItem.SettingsKey = "MainForm.dialledCallsToolStripMenuItem";
			dialledCallsToolStripMenuItem.Tag = "DC";
			dialledCallsToolStripMenuItem.Text = "&Dialled Calls";
// 
// receivedCallsMenuItem
// 
			receivedCallsMenuItem.Name = "receivedCallsMenuItem";
			receivedCallsMenuItem.SettingsKey = "MainForm.toolStripMenuItem1";
			receivedCallsMenuItem.Tag = "RC";
			receivedCallsMenuItem.Text = "&Received Calls";
// 
// toolStripSeparator2
// 
			toolStripSeparator2.Name = "toolStripSeparator2";
			toolStripSeparator2.SettingsKey = "MainForm.toolStripSeparator2";
// 
// fixedDiallingMenuItem
// 
			fixedDiallingMenuItem.Name = "fixedDiallingMenuItem";
			fixedDiallingMenuItem.SettingsKey = "MainForm.toolStripMenuItem2";
			fixedDiallingMenuItem.Tag = "FD";
			fixedDiallingMenuItem.Text = "&Fixed Dialling";
// 
// chPbID
// 
			chPbID.Text = "ID";
// 
// chPbName
// 
			chPbName.Text = "Name";
// 
// chPbFone
// 
			chPbFone.Text = "Phone Number";
// 
// tabComposer
// 
			tabComposer.BackColor = System.Drawing.SystemColors.Window;
			tabComposer.Controls.Add(this.cmbMessageStore);
			tabComposer.Controls.Add(label5);
			tabComposer.Controls.Add(this.chkDelivery);
			tabComposer.Controls.Add(this.btnSend);
			tabComposer.Controls.Add(this.btnSave);
			tabComposer.Controls.Add(this.cmbClass);
			tabComposer.Controls.Add(label4);
			tabComposer.Controls.Add(this.cmbEncoding);
			tabComposer.Controls.Add(label3);
			tabComposer.Controls.Add(this.txtMessage);
			tabComposer.Controls.Add(this.txtTO);
			tabComposer.Controls.Add(this.label2);
			tabComposer.Controls.Add(label1);
			tabComposer.Location = new System.Drawing.Point(4, 22);
			tabComposer.Name = "tabComposer";
			tabComposer.Padding = new System.Windows.Forms.Padding(3);
			tabComposer.Size = new System.Drawing.Size(462, 377);
			tabComposer.TabIndex = 3;
			tabComposer.Text = "Composer";
			tabComposer.Enter += new System.EventHandler(this.composerShown);
// 
// cmbMessageStore
// 
			this.cmbMessageStore.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbMessageStore.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmbMessageStore.FormattingEnabled = true;
			this.cmbMessageStore.Items.AddRange(new object[] {
            "Phone",
            "SIM"});
			this.cmbMessageStore.Location = new System.Drawing.Point(114, 259);
			this.cmbMessageStore.Name = "cmbMessageStore";
			this.cmbMessageStore.Size = new System.Drawing.Size(228, 21);
			this.cmbMessageStore.TabIndex = 12;
			this.toolTip.SetToolTip(this.cmbMessageStore, "Required Only for Saving");
// 
// label5
// 
			label5.AutoSize = true;
			label5.FlatStyle = System.Windows.Forms.FlatStyle.System;
			label5.Location = new System.Drawing.Point(26, 259);
			label5.Name = "label5";
			label5.Size = new System.Drawing.Size(74, 13);
			label5.TabIndex = 11;
			label5.Text = "Message Store";
// 
// chkDelivery
// 
			this.chkDelivery.AutoSize = true;
			this.chkDelivery.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chkDelivery.Location = new System.Drawing.Point(27, 295);
			this.chkDelivery.Name = "chkDelivery";
			this.chkDelivery.Size = new System.Drawing.Size(107, 18);
			this.chkDelivery.TabIndex = 10;
			this.chkDelivery.Text = "&Delivery Report";
// 
// btnSend
// 
			this.btnSend.Location = new System.Drawing.Point(165, 338);
			this.btnSend.Name = "btnSend";
			this.btnSend.Size = new System.Drawing.Size(124, 25);
			this.btnSend.TabIndex = 9;
			this.btnSend.Text = "Send";
			this.btnSend.Click += new System.EventHandler(this.sendSM);
// 
// btnSave
// 
			this.btnSave.Location = new System.Drawing.Point(23, 338);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(116, 26);
			this.btnSave.TabIndex = 8;
			this.btnSave.Text = "&Save";
			this.btnSave.Click += new System.EventHandler(this.saveMessage);
// 
// cmbClass
// 
			this.cmbClass.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbClass.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmbClass.FormattingEnabled = true;
			this.cmbClass.Items.AddRange(new object[] {
            "Class 0 -- Flash SMS",
            "Class 1",
            "Class 2",
            "Class 3"});
			this.cmbClass.Location = new System.Drawing.Point(114, 221);
			this.cmbClass.Name = "cmbClass";
			this.cmbClass.Size = new System.Drawing.Size(228, 21);
			this.cmbClass.TabIndex = 7;
// 
// label4
// 
			label4.AutoSize = true;
			label4.FlatStyle = System.Windows.Forms.FlatStyle.System;
			label4.Location = new System.Drawing.Point(23, 221);
			label4.Name = "label4";
			label4.Size = new System.Drawing.Size(74, 13);
			label4.TabIndex = 6;
			label4.Text = "Message Class";
// 
// cmbEncoding
// 
			this.cmbEncoding.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbEncoding.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmbEncoding.FormattingEnabled = true;
			this.cmbEncoding.Items.AddRange(new object[] {
            "GSM",
            "OCTET",
            "UCS2"});
			this.cmbEncoding.Location = new System.Drawing.Point(114, 185);
			this.cmbEncoding.Name = "cmbEncoding";
			this.cmbEncoding.Size = new System.Drawing.Size(228, 21);
			this.cmbEncoding.TabIndex = 5;
// 
// label3
// 
			label3.AutoSize = true;
			label3.FlatStyle = System.Windows.Forms.FlatStyle.System;
			label3.Location = new System.Drawing.Point(23, 185);
			label3.Name = "label3";
			label3.Size = new System.Drawing.Size(48, 13);
			label3.TabIndex = 4;
			label3.Text = "Encoding";
// 
// txtMessage
// 
			this.txtMessage.AutoSize = false;
			this.txtMessage.Location = new System.Drawing.Point(113, 58);
			this.txtMessage.MaxLength = 160;
			this.txtMessage.Multiline = true;
			this.txtMessage.Name = "txtMessage";
			this.txtMessage.Size = new System.Drawing.Size(229, 114);
			this.txtMessage.TabIndex = 3;
// 
// txtTO
// 
			this.txtTO.AutoSize = false;
			this.txtTO.Location = new System.Drawing.Point(112, 26);
			this.txtTO.MaxLength = 20;
			this.txtTO.Multiline = true;
			this.txtTO.Name = "txtTO";
			this.txtTO.Size = new System.Drawing.Size(230, 20);
			this.txtTO.TabIndex = 2;
// 
// label2
// 
			this.label2.AutoSize = true;
			this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label2.Location = new System.Drawing.Point(23, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(46, 13);
			this.label2.TabIndex = 1;
			this.label2.Text = "Message";
// 
// label1
// 
			label1.AutoSize = true;
			label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			label1.Location = new System.Drawing.Point(23, 26);
			label1.Name = "label1";
			label1.Size = new System.Drawing.Size(16, 13);
			label1.TabIndex = 0;
			label1.Text = "To";
// 
// chEncoding
// 
			chEncoding.Text = "Message Encoding";
// 
// ctxMessages
// 
			ctxMessages.AllowDrop = true;
			ctxMessages.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
				mctxMsgDelete
			});
			ctxMessages.Location = new System.Drawing.Point(23, 61);
			ctxMessages.Name = "ctxMessages";
			ctxMessages.Size = new System.Drawing.Size(148, 26);
// 
// mctxMsgDelete
// 
			mctxMsgDelete.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
			mctxMsgDelete.Name = "mctxMsgDelete";
			mctxMsgDelete.SettingsKey = "MainForm.mctxMsgDelete";
			mctxMsgDelete.Text = "&Delete Message";
			mctxMsgDelete.Click += new System.EventHandler(this.deleteSM);
// 
// ctxPB
// 
			ctxPB.AllowDrop = true;
			ctxPB.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
				mctxPBDelete
			});
			ctxPB.Location = new System.Drawing.Point(23, 61);
			ctxPB.Name = "ctxMessages";
			ctxPB.Size = new System.Drawing.Size(144, 26);
// 
// mctxPBDelete
// 
			mctxPBDelete.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
			mctxPBDelete.Name = "mctxPBDelete";
			mctxPBDelete.SettingsKey = "MainForm.mctxMsgDelete";
			mctxPBDelete.Text = "&Delete Contact";
			mctxPBDelete.Click += new System.EventHandler(this.deletePB);
// 
// toolsPB
// 
			this.toolsPB.Enabled = false;
			this.toolsPB.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.phoneBookToolStripButton,
            this.txtLocation,
            this.txtName,
            this.txtPhone,
            this.btnAddContact});
			this.toolsPB.Location = new System.Drawing.Point(3, 3);
			this.toolsPB.Name = "toolsPB";
			this.toolsPB.Raft = System.Windows.Forms.RaftingSides.None;
			this.toolsPB.Size = new System.Drawing.Size(456, 35);
			this.toolsPB.TabIndex = 0;
			this.toolsPB.Text = "Phone Book";
// 
// phoneBookToolStripButton
// 
			this.phoneBookToolStripButton.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            sIMToolStripMenuItem1,
            pBToolStripMenuItem,
            toolStripSeparator1,
            missedCallsToolStripMenuItem,
            dialledCallsToolStripMenuItem,
            receivedCallsMenuItem,
            toolStripSeparator2,
            fixedDiallingMenuItem});
			this.phoneBookToolStripButton.Name = "phoneBookToolStripButton";
			this.phoneBookToolStripButton.SettingsKey = "MainForm.phoneBookToolStripButton";
			this.phoneBookToolStripButton.Text = "Phone &Book";
			this.phoneBookToolStripButton.DropDownItemClicked += new System.Windows.Forms.ToolStripItemClickedEventHandler(this.phoneBookSelected);
// 
// txtLocation
// 
			this.txtLocation.AutoToolTip = true;
			this.txtLocation.Name = "txtLocation";
			this.txtLocation.SettingsKey = "MainForm.toolStripTextBox1";
			this.txtLocation.Size = new System.Drawing.Size(100, 35);
			this.txtLocation.Text = "ID";
			this.txtLocation.ToolTipText = "Location in Address Book";
// 
// txtName
// 
			this.txtName.AutoToolTip = true;
			this.txtName.Name = "txtName";
			this.txtName.SettingsKey = "MainForm.aToolStripButton";
			this.txtName.Size = new System.Drawing.Size(100, 35);
			this.txtName.Text = "Name";
			this.txtName.ToolTipText = "Name of Contact";
// 
// txtPhone
// 
			this.txtPhone.AutoToolTip = true;
			this.txtPhone.Name = "txtPhone";
			this.txtPhone.SettingsKey = "MainForm.phoneToolStripButton";
			this.txtPhone.Size = new System.Drawing.Size(100, 35);
			this.txtPhone.Text = "Phone";
			this.txtPhone.ToolTipText = "Phone Number";
// 
// btnAddContact
// 
			this.btnAddContact.Name = "btnAddContact";
			this.btnAddContact.SettingsKey = "MainForm.addContactToolStripButton";
			this.btnAddContact.Text = "Add Contact";
			this.btnAddContact.Click += new System.EventHandler(this.addContact);
// 
// toolsMessages
// 
			this.toolsMessages.Enabled = false;
			this.toolsMessages.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            messageStoreToolStripButton,
            this.messageFolderToolStripButton,
            this.fetchToolStripButton,
            this.lblStatusMsg});
			this.toolsMessages.Location = new System.Drawing.Point(3, 3);
			this.toolsMessages.Name = "toolsMessages";
			this.toolsMessages.Raft = System.Windows.Forms.RaftingSides.None;
			this.toolsMessages.Size = new System.Drawing.Size(456, 36);
			this.toolsMessages.TabIndex = 2;
			this.toolsMessages.Text = "toolStrip1";
// 
// messageFolderToolStripButton
// 
			this.messageFolderToolStripButton.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
			this.messageFolderToolStripButton.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.readToolStripMenuItem,
            this.unreadToolStripMenuItem,
            this.sentToolStripMenuItem,
            this.unsentToolStripMenuItem});
			this.messageFolderToolStripButton.Name = "messageFolderToolStripButton";
			this.messageFolderToolStripButton.SettingsKey = "MainForm.messageFolderToolStripButton";
			this.messageFolderToolStripButton.Text = "&Message Folder";
			this.messageFolderToolStripButton.DropDownItemClicked += new System.Windows.Forms.ToolStripItemClickedEventHandler(this.folderSelected);
// 
// readToolStripMenuItem
// 
			this.readToolStripMenuItem.Name = "readToolStripMenuItem";
			this.readToolStripMenuItem.SettingsKey = "MainForm.readToolStripMenuItem";
			this.readToolStripMenuItem.Text = "&Read";
// 
// unreadToolStripMenuItem
// 
			this.unreadToolStripMenuItem.Name = "unreadToolStripMenuItem";
			this.unreadToolStripMenuItem.SettingsKey = "MainForm.unreadToolStripMenuItem";
			this.unreadToolStripMenuItem.Text = "&Unread";
// 
// sentToolStripMenuItem
// 
			this.sentToolStripMenuItem.Name = "sentToolStripMenuItem";
			this.sentToolStripMenuItem.SettingsKey = "MainForm.sentToolStripMenuItem";
			this.sentToolStripMenuItem.Text = "&Sent";
// 
// unsentToolStripMenuItem
// 
			this.unsentToolStripMenuItem.Name = "unsentToolStripMenuItem";
			this.unsentToolStripMenuItem.SettingsKey = "MainForm.unsentToolStripMenuItem";
			this.unsentToolStripMenuItem.Text = "U&nsent";
// 
// fetchToolStripButton
// 
			this.fetchToolStripButton.Name = "fetchToolStripButton";
			this.fetchToolStripButton.SettingsKey = "MainForm.fetchToolStripButton";
			this.fetchToolStripButton.Text = "&Fetch";
			this.fetchToolStripButton.Click += new System.EventHandler(this.fetchMessages);
// 
// lblStatusMsg
// 
			this.lblStatusMsg.Name = "lblStatusMsg";
			this.lblStatusMsg.SettingsKey = "MainForm.statusToolStripButton";
			this.lblStatusMsg.Text = "Status";
// 
// leftRaftingContainer
// 
			this.leftRaftingContainer.Dock = System.Windows.Forms.DockStyle.Left;
			this.leftRaftingContainer.Name = "leftRaftingContainer";
// 
// rightRaftingContainer
// 
			this.rightRaftingContainer.Dock = System.Windows.Forms.DockStyle.Right;
			this.rightRaftingContainer.Name = "rightRaftingContainer";
// 
// bottomRaftingContainer
// 
			this.bottomRaftingContainer.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.bottomRaftingContainer.Name = "bottomRaftingContainer";
// 
// tabbedPane
// 
			this.tabbedPane.Controls.Add(this.tabPhoneInfo);
			this.tabbedPane.Controls.Add(this.tabMessages);
			this.tabbedPane.Controls.Add(this.tabPB);
			this.tabbedPane.Controls.Add(tabComposer);
			this.tabbedPane.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabbedPane.Location = new System.Drawing.Point(0, 53);
			this.tabbedPane.Name = "tabbedPane";
			this.tabbedPane.SelectedIndex = 0;
			this.tabbedPane.Size = new System.Drawing.Size(470, 403);
			this.tabbedPane.TabIndex = 4;
// 
// tabPhoneInfo
// 
			this.tabPhoneInfo.Controls.Add(this.txtPhoneInfo);
			this.tabPhoneInfo.Location = new System.Drawing.Point(4, 22);
			this.tabPhoneInfo.Name = "tabPhoneInfo";
			this.tabPhoneInfo.Padding = new System.Windows.Forms.Padding(3);
			this.tabPhoneInfo.Size = new System.Drawing.Size(462, 377);
			this.tabPhoneInfo.TabIndex = 0;
			this.tabPhoneInfo.Text = "Phone Information";
// 
// txtPhoneInfo
// 
			this.txtPhoneInfo.AutoSize = false;
			this.txtPhoneInfo.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtPhoneInfo.Enabled = false;
			this.txtPhoneInfo.Font = new System.Drawing.Font("Lucida Console", 13F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.txtPhoneInfo.Location = new System.Drawing.Point(3, 3);
			this.txtPhoneInfo.Margin = new System.Windows.Forms.Padding(10);
			this.txtPhoneInfo.Multiline = true;
			this.txtPhoneInfo.Name = "txtPhoneInfo";
			this.txtPhoneInfo.Size = new System.Drawing.Size(456, 371);
			this.txtPhoneInfo.TabIndex = 0;
// 
// tabMessages
// 
			this.tabMessages.Controls.Add(this.listMessages);
			this.tabMessages.Controls.Add(this.toolsMessages);
			this.tabMessages.Location = new System.Drawing.Point(4, 22);
			this.tabMessages.Name = "tabMessages";
			this.tabMessages.Padding = new System.Windows.Forms.Padding(3);
			this.tabMessages.Size = new System.Drawing.Size(462, 377);
			this.tabMessages.TabIndex = 1;
			this.tabMessages.Text = "Messages";
// 
// listMessages
// 
			this.listMessages.Activation = System.Windows.Forms.ItemActivation.OneClick;
			this.listMessages.AllowColumnReorder = true;
			this.listMessages.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            chMsgID,
            chMsgType,
            chEncoding,
            chMsgText,
            chFromTo,
            chTimestamp});
			this.listMessages.ContextMenuStrip = ctxMessages;
			this.listMessages.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listMessages.FullRowSelect = true;
			this.listMessages.Location = new System.Drawing.Point(3, 39);
			this.listMessages.Name = "listMessages";
			this.listMessages.Size = new System.Drawing.Size(456, 335);
			this.listMessages.TabIndex = 3;
			this.listMessages.View = System.Windows.Forms.View.Details;
// 
// tabPB
// 
			this.tabPB.Controls.Add(this.listPB);
			this.tabPB.Controls.Add(this.toolsPB);
			this.tabPB.Location = new System.Drawing.Point(4, 22);
			this.tabPB.Name = "tabPB";
			this.tabPB.Padding = new System.Windows.Forms.Padding(3);
			this.tabPB.Size = new System.Drawing.Size(462, 377);
			this.tabPB.TabIndex = 2;
			this.tabPB.Text = "Phone Book";
// 
// listPB
// 
			this.listPB.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            chPbID,
            chPbName,
            chPbFone});
			this.listPB.ContextMenuStrip = ctxPB;
			this.listPB.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listPB.FullRowSelect = true;
			this.listPB.Location = new System.Drawing.Point(3, 38);
			this.listPB.Name = "listPB";
			this.listPB.Size = new System.Drawing.Size(456, 336);
			this.listPB.TabIndex = 1;
			this.listPB.View = System.Windows.Forms.View.Details;
// 
// toolTip
// 
			this.toolTip.IsBalloon = true;
			this.toolTip.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info;
			this.toolTip.ToolTipTitle = "Information";
// 
// MainForm
// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(470, 456);
			this.Controls.Add(this.tabbedPane);
			this.Controls.Add(this.leftRaftingContainer);
			this.Controls.Add(this.rightRaftingContainer);
			this.Controls.Add(topRaftingContainer);
			this.Controls.Add(this.bottomRaftingContainer);
			this.Name = "MainForm";
			this.Text = "My eXaMS App";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			myToolStrip.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(topRaftingContainer)).EndInit();
			topRaftingContainer.ResumeLayout(false);
			topRaftingContainer.PerformLayout();
			tabComposer.ResumeLayout(false);
			tabComposer.PerformLayout();
			ctxMessages.ResumeLayout(false);
			ctxPB.ResumeLayout(false);
			this.toolsPB.ResumeLayout(false);
			this.toolsPB.PerformLayout();
			this.toolsMessages.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.leftRaftingContainer)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.rightRaftingContainer)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.bottomRaftingContainer)).EndInit();
			this.tabbedPane.ResumeLayout(false);
			this.tabPhoneInfo.ResumeLayout(false);
			this.tabMessages.ResumeLayout(false);
			this.tabMessages.PerformLayout();
			this.tabPB.ResumeLayout(false);
			this.tabPB.PerformLayout();
			this.ResumeLayout(false);
			this.PerformLayout();

		}

		private void startCommunication(object sender, EventArgs e)	{
			if(xms == null)
				xms = new XMS();
			this.Cursor = Cursors.WaitCursor;
			this.UseWaitCursor = true;
			xms.Modem = this.currentModem;
			try {
				xms.Initialize();
			} catch (ModemException me) {
				this.Cursor = Cursors.Default;
				this.UseWaitCursor = false;
				MessageBox.Show(this, me.InnerException.Message, "Connectivity Error",
					MessageBoxButtons.OK, MessageBoxIcon.Stop, MessageBoxDefaultButton.Button1);
				return;
			}
			comm = xms.GetCommunicator();
			if(comm == null) {
				MessageBox.Show("No communicator found for "+currentModem.Name);
				return;
			}
			this.btnStart.Enabled = false;
			this.cmbModems.Enabled = false;
			this.toolsMessages.Enabled = true;
			this.toolsPB.Enabled = true;
			this.Cursor = Cursors.Default;
			this.UseWaitCursor = false;

			fillPhoneInfo();
			lblStatusMsg.Text = "Message Store: " + currentMS.ToString() + ", Message Folder: " + currentMF.ToString();
		}

		private void fillPhoneInfo() {
			string txt = "Phone Information\r\n" +
						 "-----------------\r\n";
			txt += "Manufacturer: " + comm.Manufacturer + "\r\n";
			txt += "Model: " + comm.Model + "\r\n";
			txt += "Revision:\r\n" + comm.Revision + "\r\n";
			txt += "Serial Number: " + comm.SerialNo + "\r\n\r\n";
			txt += "Battery Charge(1-100): "+ comm.GetBatteryCharge() + "\r\n";
			txt += "Signal Strength(1-32): " + comm.GetSignalStrength() + "\r\n";
			txt += "Message Center: " + comm.GetMessageCenter() + "\r\n";

			this.txtPhoneInfo.Text = txt;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing) {
			if (disposing && (components != null)) {
				components.Dispose();
			}
			if (xms != null) {
				xms.Dispose();
			}
			base.Dispose(disposing);
		}

		private void folderSelected(object sender, ToolStripItemClickedEventArgs e)	{
			if (e.ClickedItem.Text.Equals("&Read"))
				currentMF = MessageFolder.Read;
			else if (e.ClickedItem.Text.Equals("&Unread"))
				currentMF = MessageFolder.Unread;
			else if (e.ClickedItem.Text.Equals("&Sent"))
				currentMF = MessageFolder.Sent;
			else if (e.ClickedItem.Text.Equals("U&nsent"))
				currentMF = MessageFolder.Unsent;
			lblStatusMsg.Text = "Message Store: " + currentMS.ToString() + ", Message Folder: " + currentMF.ToString();
		}

		private void storeSelected(object sender, ToolStripItemClickedEventArgs e) {
			if (e.ClickedItem.Text == "&Phone")
				currentMS = MessageStore.Phone;
			else if (e.ClickedItem.Text == "&SIM")
				currentMS = MessageStore.SIM;
			lblStatusMsg.Text = "Message Store: " + currentMS.ToString() + ", Message Folder: " + currentMF.ToString();
		}

		private void fetchMessages(object sender, EventArgs e) {
			ICollection coll = null;
			
			this.Cursor = Cursors.WaitCursor;
			this.UseWaitCursor = true;

			comm.SetMessageStore(currentMS);
			coll = comm.GetMessages(currentMF);

			this.listMessages.BeginUpdate();
			this.listMessages.Items.Clear();
			foreach (SMS s in coll)
				addSMS(s);
			this.listMessages.EndUpdate();
	
			this.Cursor = Cursors.Default;
			this.UseWaitCursor = false;
		}

		private void addSMS(SMS s) {
			object pk = s.Packet;
			ListViewItem item = this.listMessages.Items.Add(s.ID.ToString());
			item.Tag = s.ID;
			item.SubItems.Add(GetSmsPacketType(pk));
			item.SubItems.Add(GetSmsEncoding(pk));
			item.SubItems.Add(GetSmsText(pk));
			item.SubItems.Add(GetSmsAddress(pk));
			item.SubItems.Add(GetSmsTimestamp(pk));
		}

		private string GetSmsEncoding(object pk) {
			if (pk is SmsDeliverPacket)
				return ((SmsDeliverPacket)pk).MessageEncoding.ToString();
			else if (pk is SmsStatusReportPacket)
				return "N/A";
			else if (pk is SmsSubmitPacket)
				return ((SmsSubmitPacket)pk).MessageEncoding.ToString();
			else
				return "Unknown";
		}

		private string GetSmsTimestamp(object pk) {
			if (pk is SmsDeliverPacket)
				return ((SmsDeliverPacket)pk).Timestamp.ToString();
			else if (pk is SmsStatusReportPacket)
				return ((SmsStatusReportPacket)pk).Timestamp.ToString();
			else if (pk is SmsSubmitPacket)
				return "N/A";
			else
				return "Unknown";
		}

		private string GetSmsAddress(object pk) {
			if (pk is SmsDeliverPacket)
				return ((SmsDeliverPacket)pk).OriginatingAddress;
			else if (pk is SmsStatusReportPacket)
				return ((SmsStatusReportPacket)pk).OriginatingAddress;
			else if (pk is SmsSubmitPacket)
				return ((SmsSubmitPacket)pk).DestinationAddress;
			else
				return "Unknown";
		}

		private string GetSmsText(object pk) {
			if (pk is SmsDeliverPacket)
				return ((SmsDeliverPacket)pk).MessageText;
			else if (pk is SmsStatusReportPacket) {
				SmsStatusReportPacket p = (SmsStatusReportPacket)pk;
				string text = "Delivered: "+p.Delivered+"\r\nTimestamp: "+p.Timestamp+
					"\r\nDelivery Timestamp: "+p.DeliveryTimestamp;
				return text;
			}  else if (pk is SmsSubmitPacket)
				return ((SmsSubmitPacket)pk).MessageText;
			else
				return "Unknown";
		}
		
		private string GetSmsPacketType(object pk) {
			if (pk is SmsDeliverPacket)
				return "Incoming Message";
			else if (pk is SmsStatusReportPacket)
				return "Delivery Report";
			else if (pk is SmsSubmitPacket)
				return "Outgoing Message";
			else
				return "Unknown";
		}

		private void phoneBookSelected(object sender, ToolStripItemClickedEventArgs e) {
			string book = (string)e.ClickedItem.Tag;

			this.Cursor = Cursors.WaitCursor;
			this.UseWaitCursor = true;

			try {
				comm.SetPhoneBook(book);
			} catch (NoSuchPhoneBookException) {
				MessageBox.Show(this, "No Such Phone Book: "+e.ClickedItem.Text, "Error", MessageBoxButtons.OK);
				return;
			}
			this.currentPB = book;
			PhoneBook pb = comm.GetContacts();
			PhoneBookEntry[] pbe = pb.Entries;

			this.listPB.BeginUpdate();
			this.listPB.Items.Clear();

			foreach (PhoneBookEntry p in pbe)
				addPhone(p);

			this.listPB.EndUpdate();

			this.Cursor = Cursors.Default;
			this.UseWaitCursor = false;
		}

		private void addPhone(PhoneBookEntry p) {
			ListViewItem item = this.listPB.Items.Add(p.Location.ToString());
			item.Tag = p.Location;
			item.SubItems.Add(p.Name);
			item.SubItems.Add(p.Phone);
		}

		private bool IsValidComposer() {
			if (txtTO.Text.Trim().Length == 0)
				return false;
			if (txtMessage.Text.Trim().Length == 0)
				return false;

			return true;
		}

		private void saveMessage(object sender, EventArgs e) {
			if (!IsValidComposer()) {
				MessageBox.Show(this, "Fill all the required details", "Error", MessageBoxButtons.OK);
				return;
			}
			this.Cursor = Cursors.WaitCursor;
			this.UseWaitCursor = true;

			SmsSubmitPacket pkt = new SmsSubmitPacket();
			pkt.DestinationAddress_ToA = (byte)AddressType.Generic;
			pkt.DestinationAddress = this.txtTO.Text;
			pkt.MessageClass = (MessageClass)this.cmbClass.SelectedIndex;
			pkt.MessageEncoding = (EncodingType)this.cmbEncoding.SelectedIndex;
			pkt.MessageText = this.txtMessage.Text;
			pkt.WantsDeliveryReport = chkDelivery.Checked;
			pkt.Validity = ValidityType.Relative;
			pkt.Expires = new TimeSpan(20, 0, 0, 0);

			comm.SetMessageStore(GetMsgStore(this.cmbMessageStore.SelectedItem.ToString()));
			comm.Save(pkt);

			this.Cursor = Cursors.Default;
			this.UseWaitCursor = false;
		}

		private MessageStore GetMsgStore(string text) {
			if (text.Trim().Equals("Phone"))
				return MessageStore.Phone;
			else if (text.Trim().Equals("SIM"))
				return MessageStore.SIM;
			else
				return MessageStore.SIM;
		}

		private void composerShown(object sender, EventArgs e) {
			this.cmbEncoding.SelectedIndex = 0;
			this.cmbMessageStore.SelectedIndex = 0;
			this.cmbClass.SelectedIndex = 1;
		}

		private void addContact(object sender, EventArgs e)	{
			int id = 0;
			string name = txtName.Text;
			string phone = txtPhone.Text;

			try {
				id = Int32.Parse(txtLocation.Text);
			} catch (Exception ) {
				MessageBox.Show("ID is a numeric field", "Error",MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			if (name.Length == 0 && phone.Length == 0) {
				MessageBox.Show("Please enter at least one either phone or name", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			if(!(currentPB.Equals("ME") || currentPB.Equals("SM"))) {
				MessageBox.Show("This is readonly phonebook", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			try {
				comm.SetPhoneBook(currentPB);
			} catch (NoSuchPhoneBookException) {
				MessageBox.Show(this, "No Such Phone Book: " + currentPB, "Error", MessageBoxButtons.OK);
				return;
			}
			comm.WriteContact(new PhoneBookEntry(id, name, phone, 0x81, currentPB));
		}

		private void sendSM(object sender, EventArgs e)	{
			if (!IsValidComposer()) {
				MessageBox.Show(this, "Fill all the required details", "Error", MessageBoxButtons.OK);
				return;
			}
			this.Cursor = Cursors.WaitCursor;
			this.UseWaitCursor = true;

			SmsSubmitPacket pkt = new SmsSubmitPacket();
			pkt.DestinationAddress_ToA = (byte)AddressType.Generic;
			pkt.DestinationAddress = this.txtTO.Text;
			pkt.MessageClass = (MessageClass)this.cmbClass.SelectedIndex;
			pkt.MessageEncoding = (EncodingType)this.cmbEncoding.SelectedIndex;
			pkt.MessageText = this.txtMessage.Text;
			pkt.WantsDeliveryReport = chkDelivery.Checked;
			pkt.Validity = ValidityType.Relative;
			pkt.Expires = new TimeSpan(20, 0, 0, 0);

			comm.Send(pkt);
			this.Cursor = Cursors.Default;
			this.UseWaitCursor = false;
		}

		private void deleteSM(object sender, EventArgs e)
		{
			if (listMessages.SelectedIndices.Count == 0)
				return;
			if (MessageBox.Show(this, "Are you sure you want to delete " + 
					listMessages.SelectedIndices.Count + " message(s) ?", "Question", 
					MessageBoxButtons.YesNo, MessageBoxIcon.Question, 
					MessageBoxDefaultButton.Button2) == DialogResult.Yes) {
				this.Cursor = Cursors.WaitCursor;
				this.UseWaitCursor = true;
				listMessages.BeginUpdate();
				foreach (ListViewItem i in listMessages.SelectedItems) {
					int x = (int)i.Tag;
					this.comm.DeleteMessage(x);
					listMessages.Items.Remove(i);
				}
				listMessages.EndUpdate();
				this.Cursor = Cursors.Default;
				this.UseWaitCursor = false;
			}
		}

		private void deletePB(object sender, EventArgs e)
		{
			if (listPB.SelectedIndices.Count == 0)
				return;
			if (MessageBox.Show(this, "Are you sure you want to delete " +
					listPB.SelectedIndices.Count + " contact(s) ?", "Question",
					MessageBoxButtons.YesNo, MessageBoxIcon.Question,
					MessageBoxDefaultButton.Button2) == DialogResult.Yes) {
				this.Cursor = Cursors.WaitCursor;
				this.UseWaitCursor = true;
				listPB.BeginUpdate();
				foreach (ListViewItem i in listPB.SelectedItems) {
					int x = (int)i.Tag;
					this.comm.DeleteContact(x);
					listPB.Items.Remove(i);
				}
				listPB.EndUpdate();
				this.Cursor = Cursors.Default;
				this.UseWaitCursor = false;
			}
		}
	}
}