﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

using NUnit.Core;
using NUnit.Framework;

using MonsieurWJ.LibXMS2;

#endregion

namespace MonsieurWJ.LibXMS2.NTests {

	[TestFixture(Description ="SMS DELIVER Packet Test")]
	public class SmsDeliverPacketTest {

		[Test(Description = "Tests Parse method")]
		public void TestParse() {
			string sms1 = "0791198911009989240B914747030152F20000"+
				"4070920202242294CD703EEC5E83A669B7CE7CD7818C77B2AEEA1416"+
				"99C9A23528641615BCD82B16F3291A3EA3FCDDD68182EEF41C0D8286D"+
				"DE4721EC40BBBD373340C8603E4C3E8F7DB357EB77D0D1FF5AD0335E56"+
				"9729D0D8286DDE4721EC46BCBD3E43A1B1E7693CB7940DA4D4E87E9E976"+
				"79EE1ABFDB3E054F5A86B3F3A026C8FC9683DA6F79D907";
			string text1 = "Mayank Sin:fw: Fwd:UNBELIEVABLE\n"+
					"<1/11>\n\r"+
					">From: Anish Pandey <anish008@yahoo.com>\r"+
					">To: Mridul Pandey <mridulpandey@indiatimes.com>\n"+
					"<Reply M for more>";
			string phone1 = "+74743010252";
						   //198911009989
			string smsc1 = "+919811009998";

			string sms2 = "0791198919300099040C91198919726827"+
				"0000408051005130220AD3BABC0C9AD3EB6417";
			string text2 = "Sure stud.";
			string phone2 = "+919891278672";
			string smsc2 =  "+919891030099";

			string sms3 = "07911989939099990409D0C83A7D8C06000040601231821122A0C87408242D8FD161F9B90C72BFEF"+
				"219035CC4E93D3F43CE86D06D5E5A071584E0695F1F0B4BC3C07A5DDA01A881CCECF5DA0A47BFC6E"+
				"A7DD679009F4AED3CFEFB4FB0C1A87D9EC39C8FDA683C2F6709A1D16B3CBA0B41B749687C7659730"+
				"CC0EBBC765D0382C97E741E6B7FC1E9693416933485E1EA3C3F27319949E83EE693A3AED06C56A20"+
				"72383F07BDCD";
			string text3="Hi! Recharge now! Validity of ur card expires in 5 days. Incoming & ou"+
				"tgoing calls not available in grace.Balance carry forward if recharge is within "+
				"15 days of";
			string phone3 = "Hutch";
			string smsc3 = "+919839099999";

			Encoding enc = HexEncoding.HEX;
			
			byte[] bytes = enc.GetBytes(sms1.ToCharArray());
			
			SmsDeliverPacket pk = SmsDeliverPacket.Parse(bytes);
			Assert.AreEqual(text1, pk.MessageText);
			Assert.AreEqual(phone1, pk.OriginatingAddress);
			Assert.AreEqual(smsc1, pk.SMSC);

			bytes = enc.GetBytes(sms2.ToCharArray());
			
			pk = SmsDeliverPacket.Parse(bytes);
			Assert.AreEqual(text2, pk.MessageText);
			Assert.AreEqual(phone2, pk.OriginatingAddress);
			Assert.AreEqual(smsc2, pk.SMSC);

			bytes = enc.GetBytes(sms3.ToCharArray());

			pk = SmsDeliverPacket.Parse(bytes);
			Assert.AreEqual(text3, pk.MessageText);
			Assert.AreEqual(phone3, pk.OriginatingAddress);
			Assert.AreEqual(smsc3, pk.SMSC);

		}
	}
}
