#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

using NUnit.Core;
using NUnit.Framework;

using MonsieurWJ.LibXMS2;

#endregion

namespace MonsieurWJ.LibXMS2.NTests {

	[TestFixture(Description = "SMS STATUS REPORT Packet Test")]
	public class SmsStatusReportPacketTest {
		[Test(Description = "Tests Parse method")]
		public void TestParse() {
			string sms = "0791198911009989067F0C91198919519401408010203355224080102043202200";
			bool delivered = true;
			string smsc = "+919811009998";
			string phone = "+919891154910";
			byte[] bytes = HexEncoding.HEX.GetBytes(sms);

			SmsStatusReportPacket pk = SmsStatusReportPacket.Parse(bytes);
			Assert.AreEqual(delivered, pk.Delivered);
			Assert.AreEqual(phone, pk.OriginatingAddress);
			Assert.AreEqual(smsc, pk.SMSC);
		}
	}
}

